# Vulnerability History Project ![VHP Tests](https://github.com/VulnerabilityHistoryProject/vulnerability-history/workflows/VHP%20Tests/badge.svg)

# Getting Set Up

* Install Ruby 2.6
* Install NodeJS (latest, not LTS)
* Install Yarn
* Install PostgreSQL (latest)
* In PostgreSQL pgAdmin, create a user called "vhp". Set the permissions to "Can Log In". Create a random password and set that password for the vhp user. Put that password into secrets.yml (see next bullet). Create two databases: "vhp" and "vhp_test"
* Create a config/secrets.yml based on config/secrets.default.yml. Follow the comments in that file.
* After that, we'll need to install all of our dependencies. From the root of the repo on the command line run:

```
  $ yarn install
  $ bundle install
```

Then, let's set up our database and load our data:
```
  $ rails db:schema:load
  $ rails data:clear data:all
  $ rails server
```

That second one can take a while. Once the server is up, go to `http://localhost:3000` to see the site.

If you are working on the frontend, it's useful to run Webpacker's dev server:

```
  $ ruby bin/webpack-dev-server
```

This speeds up rebuilding the frontend JS, CSS, etc.

# Finding useful commands

To find out useful commands for working with data:

`$ rails -T`

# Rebuild the database

If `db/schema.rb` has changed recently, you'll need to rebuild the database:

`$ rails db:schema:load`

# Reload the production data

To load the production data from Chromium and HTTPD:

`$ rails data:all`

This is the equivalent of running:

`$ rails data:clear data:chromium data:httpd data:writing`

To skip the clone from github,

`$ rails data:chromium:nogit`
`$ rails data:httpd:nogit`

# Useful commands:

```
$ rails server
$ rails console
```

# Helpful Dev Tools

Here's a list of our favorite tools for developing this:

* [Atom](https://atom.io/) or [VS Code](https://code.visualstudio.com/)
* [Git Extensions](https://gitextensions.github.io/) for Windows Git clients
* [JSONView](https://chrome.google.com/webstore/detail/jsonview/chklaanhfefbnpoihckbnefhakgolnmc?hl=en) to format JSON responses in your browser

# The CWE csv file

To download a copy of the CWE csv file, go to https://cwe.mitre.org/data/downloads.html and download
the latest Research Concepts csv listed under 'Navigate CWE'.

Place the csv file in lib/taggers/resources/cwes.csv

On line 677 of the file, near the end of the line, change the double quotes around `"<script"` to single quotes `'script'`
