class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception

  def api_call?
    return request.path.starts_with? '/api'
  end

  def render_json_for_api(obj)
    if api_call?
      json = Rails.cache.fetch(request.path, expires_in: 12.hours) do
        Oj.dump obj, mode: :rails
      end
      render json: json
    end
  end

  # Returns integer form of param if it exists, otherwise nil
  def param_int_if_set(p)
    if params.key? p
      return params[p].to_i
    else
      return nil
    end
  end
end
