class ArticlesController < ApplicationController
  before_action :set_article, only: [:show]

  # GET /articles
  # GET /api/articles
  # GET /api/articles?cves=true
  def index
    @articles = Article.all_detailed
    render_json_for_api @articles
  end

  # GET /articles/1
  # GET /api/articles/foo-bar
  # GET /api/articles/1
  def show
    render_json_for_api @article
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_article
      db_params = { id: params[:id].to_i, slug: params[:id].to_s }
      article = Article.where('id = :id OR slug = :slug', db_params).first
      
      if article.nil?
        flash[:error] = "Error: Article #{params[:id]} not found"
        redirect_to controller: 'articles'
      else
        @article = article
      end
    end
end
