class CvesController < ApplicationController

    def index
        redirect_to :controller => 'vulnerabilities', :action => 'index' 
        #redirect_to "/api/vulnerabilities/"
    end

    # GET /cves/CVE-2013-6665
    # GET /cves/CAN-2013-6665
    def show
        param = params[:name]
        par = clean_cve(param)
        if(par == nil)
            flash[:error] = "Error: Vulnerability not found"
            redirect_to controller: 'vulnerabilities'
        else
            redirect_to :controller => 'vulnerabilities', :action => 'show', :id => Vulnerability.find_by(cve: par).id
        end
    end
    
    # The database stores CVE id in a different format. This method changes the web-based format to the database format
    def clean_cve(param)
        if param.index(/can/i) != nil
            par = param.sub!(/can/i, 'CVE')
            if Vulnerability.find_by(cve: par) != nil
                return par
            else
                return nil
            end
        elsif Vulnerability.find_by(cve: param.sub!(/cve/i, 'CVE')) != nil
            par = param.sub!(/cve/i, 'CVE')
            return par
        else
            return nil
        end
    end

    helper_method :clean_cve
end