class DevelopersController < ApplicationController
  before_action :set_developer, only: [:show]

  # GET /developers
  # GET /api/developers
  def index
    @developers = Developer.all
    render_json_for_api @developers
  end

  # GET /developers/1
  # GET /api/developers/1
  def show
    render_json_for_api @developer
  end

  def commits
    render_json_for_api Commit.select(:commit_hash)
                               .select(:message)
                               .select(:date_created)
                               .select("notes -> 'churn' AS churn")
                               .where(author_id: params[:developer_id])
  end

  private

    # Use callbacks to share common setup or constraints between actions.
    def set_developer
      if params[:id].match(/^(\d)+$/).present?
        @developer = Developer.find(params[:id])
      else
        @developer = Developer.find_by(nickname: params[:id].gsub('_', ' '))
      end
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def developer_params
      params.fetch(:developer, {})
    end
end
