class ProjectsController < ApplicationController
  before_action :set_project, only: [:show, :releases]

  # GET /projects
  # GET /api/projects
  def index
    render_json_for_api Project.all
  end

  # GET /api/projects/1
  def show
    render_json_for_api @project
  end

  # GET /api/projects/1/releases
  def releases
    render_json_for_api Release.where(project: @project)
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_project
      @project = Project.find(params[:project_id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def project_params
      params.fetch(:project, {})
    end
end
