class ReleasesController < ApplicationController
  before_action :set_release, only: [:show]

  # GET api/releases
  def index
    @releases = Release.all
    render_json_for_api @releases
  end

  # GET api/releases/1
  def show
    render_json_for_api @release
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_release
      @release = Release.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def release_params
      params.fetch(:release, {})
    end
end
