import $ from 'jquery'
import moment from 'moment'
import 'datatables.net'
import 'datatables.net-responsive-dt'
import 'datatables.net-zf'
import {hideSinglePagePagination} from 'global/datatablesTweaks'
import {shortDate} from 'global/dates' // date could be added on later

$( document ).ready( function() {
    $.ajax({
        url: "/api/commits",
        dataType: 'json',
        success: function(jsonData) {
            $('#datatable').dataTable({
                destroy: true,
                data: jsonData,
                rowCallback: function(row, data, index){
                  $(row).on('click', function(){
                    var url = window.location.href;
                    if (url.slice(-1) == "/"){
                      url += data.id;
                    } else {
                      url += '/' + data.id;
                    }
                    window.location.assign(url);
                  })
                },
                preDrawCallback: (settings) => hideSinglePagePagination(settings),
                columnDefs: [
                  { "width": "10%", "targets": 0 }
                ],
                columns: [
                    { title: 'Commit Hash', data: 'commit_hash', defaultContent: ''},
                    { title: 'Author', data: 'email', defaultContent: ''},
                    { title: 'Date Created', data: 'date_created', defaultContent: '',
                      render: function(data) {
                        return moment(data,'YYYY-MM-DD hh:mm:ss Z')
                               .format('MMMM Do YYYY, h:mm a');
                      }
                    }
                ]
            });
        }
    });

    $('#datatable').on('mouseover', 'tbody tr', function() {
        $(this).css({
           'cursor': 'pointer',
            'color': 'blue'
        });
    })

    $('#datatable').on('mouseout', 'tbody tr', function() {
        $(this).css({
            'cursor': 'default',
            'color': 'inherit'
        });
    })
});
