import $ from 'jquery'
import {friendlyCWE} from '../global/dataToPrettyStrings'
import {shortDate} from '../global/dates'

export function vulnCards(jsonData, tagMap, container = '#vuln_cards'){
  for (let v of jsonData) {
    const card = $('#vuln_card_template').clone();
    card.attr('id', '')
        .attr('href', `/vulnerabilities/${v.id}`);
    if(v.nickname.trim() != '') {
      card.find('.title-space').append(`
        <div class="title">
          <span class="${v.subdomain}-inline-logo"></span>
          ${v.nickname}
        </div>
        <div class="subtitle">${v.cve}</div>
      `);
    } else {
      card.find('.title-space').append(`
        <div class="title-only">
          <span class="${v.subdomain}-inline-logo"></span>
          ${v.cve}
        </div>
      `);
    }

    card.find('.date')
        .attr('title', v.announced)
        .html(shortDate(v.announced));
    if(v.upvotes > 0) {
      card.find('.upvote-number').html(v.upvotes);
      card.find('.upvotes i')
          .attr('title', `${v.upvotes} upvotes`)
          .attr('class', 'vhp-icon-upvote');
    }
    for(let t of v.tag_json){
      const tag = tagMap[t.id]
      if(tag.name.startsWith('CWE')){
        card.find('.cwe').html(friendlyCWE(tag.name.split(':')[1].trim()));
      }
    }
    for(let t of v.tag_json){
      const tag = tagMap[t.id]
      if(in_tag_list(tag.name)){
        card.find('.icons').append(`
          <i title="${tag.name}"
             class="vhp-icon-${tag.icon}"
             style="color: ${tag.color}" ></i>
        `)
       }
    }
    $(container).append(card);
  }
}

function in_tag_list(name) {
  return !name.startsWith('CWE')
      && !name.startsWith('Project:')
}
