require 'coderay'
require 'yaml'
require 'kramdown'
require 'rinku'
require 'sanitize'
require 'active_support'

module ApplicationHelper

  # VHP-Flavored Markdown
  #
  #  * Markdown syntax
  #  * URLs are auto-converted to an <a> tag
  #  * CVE identifiers link to the CVE database
  #  * Icons inside of colons get converted to <i> tags.
  #  * Sanitize goes over the HTML code to remove anything XSS-related
  #  * Declare the HTML to be safe
  #
  def markdown(source)
    warn 'DEPRECATED. Ruby-side VHP-flavored Markdown is SLOOOOOW! Use client-side JS instead.'
  end

  # Simplifies the CWE name if it has a nickname in parentheses function
  # Mirrored implementation: /app/assets/javascripts/global/vulnCards.js
  # Examples:
  #   "I do not want this ('I want this') not this" --> "I want this"
  #   "Just a string" --> "Just a string"
  def friendly_cwe(name)
    match = name.match(/.*\(\'(.+)\'\).*/);
    # [0] is the full string, [1] is the actual match
    return match.nil? ? name : match[1]
  end

  def pretty_code(str)
    # the [3..-1] removes the YAML front matter, "---\n"
    CodeRay.scan(str.to_yaml[3..-1], :yaml).
            div(:line_numbers => :table)
  end

  def pretty_date(source)
    source.strftime('%a %d %b %Y')
  end
end
