class Article < ApplicationRecord
  has_one :article_vulnerability, foreign_key: 'article_id'
  has_many :vulnerabilities, through: :article_vulnerability
  has_one :article_tag, foreign_key: 'article_id'
  has_many :tags, through: :article_tag
  has_one :article_filepath, foreign_key: 'article_id'
  has_many :filepaths, through: :article_filepath

  def self.all_detailed
    Article.select('articles.*')
           .select('ARRAY_AGG(filepaths.filepath) AS filepaths')
           .select('ARRAY_AGG(vulnerabilities.cve) AS cves')
           .left_outer_joins(:filepaths)
           .left_outer_joins(:vulnerabilities)
           .left_outer_joins(:tags)
           .group('articles.id')
  end

end
