class InterestingCommit < ApplicationRecord
  belongs_to :commit, foreign_key: 'commit_id'
  belongs_to :vulnerability, foreign_key: 'vulnerability_id'

  # Required by Event model
  def title
    "Interesting commit: #{commit.title}"
  end

  # Required by Event model
  def description
    <<~EOS
    Curator's note:

    #{researcher_note}

    Original commit message:

    #{commit.description}

    EOS
  end

  # Required by Event model
  def date
    commit.date
  end

  # Required by Event model
  def type
    'interesting_commit'
  end

  def researcher_note
    note
  end
end
