class Tag < ApplicationRecord
    has_many :vulnerability_tags, foreign_key: 'tag_id'
    has_many :vulnerabilities, through: :vulnerability_tags
    has_many :article_tags, foreign_key: 'tag_id'
    has_many :articles, through: :article_tags

    def self.map
      tag_query = Tag.select(:id, :name, :shortname, :color, :icon)
      tag_map = tag_query.inject({}) do |map, tag|
        map[tag.id] = {
          'name' => tag.name,
          'shortname' => tag.shortname,
          'color' => tag.color,
          'icon' => tag.icon,
        };
        map
      end
    end

    def self.lessons
      joins(:vulnerability_tags).where("name LIKE 'Lesson: %'")
    end
end
