Rails.application.routes.draw do

  root 'welcome#index'

  resources :vulnerabilities, only: [:index, :show], format: false
  resources :cves, param: :name, only: [:index, :show], format: false
  resources :developers, only: [:index, :show], format: false
  resources :commits, only: [:index, :show], format: false
  resources :releases, only: [:index, :show], format: false
  resources :tags, only: [:index, :show], format: false
  resources :fixes, only: [:show], format: false
  resources :vccs , only: [:show], format: false
  resources :articles, only: [:show, :index], format: false
  resources :projects, only: [:index], format: false

  resources :filepaths, only: [:index, :show], via: [:get], format: false,
            param: :filepath_id

  get :curate, to: 'curate#index'
  get :about, to: 'about#index'
  get :status, to: 'status#index'

  scope :api do
    resources :vulnerabilities, only: [:index, :show], :format => false do
      get :events
    end
    resources :cves, only: [:index, :show], :format => false do

    end
    resources :commits, only: [:index, :show], :format => false do
      get :developer
    end
    resources :developers, only: [:index, :show], :format => false do
      get :commits
    end
    resources :releases, only: [:index, :show], :format => false

    resources :filepaths, only: [:index, :show], via: [:get], format: false do
      get :developers, :commits, :contributors, :vulnerabilities, format: false
    end

    resources :tags, only: [:index, :show], :format => false

    resources :articles, only: [:index, :show], :format => false

    resources :projects, only: [:index, :show], :format => false do
      get :releases
    end
  end

end
