# This file is auto-generated from the current state of the database. Instead
# of editing this file, please use the migrations feature of Active Record to
# incrementally modify your database, and then regenerate this schema definition.
#
# Note that this schema.rb definition is the authoritative source for your
# database schema. If you need to create the application database on another
# system, you should be using db:schema:load, not running all the migrations
# from scratch. The latter is a flawed and unsustainable approach (the more migrations
# you'll amass, the slower it'll run and the greater likelihood for issues).
#
# It's strongly recommended that you check this file into your version control system.

ActiveRecord::Schema.define(version: 2020_10_20) do

  # These are extensions that must be enabled in order to support this database
  enable_extension "plpgsql"

  create_table "articles", force: :cascade do |t|
    t.string   "title",    null: false
    t.string   "author",   null: false
    t.string   "art",      null: false
    t.string   "blurb",    null: false
    t.string   "fulltext", null: false
    t.string   "slug",     null: false
  end

  add_index :articles, :id, unique: true

  create_table "article_vulnerabilities", force: :cascade do |t|
    t.integer :article_id,       null: false
    t.integer :vulnerability_id, null: false
  end

  add_index :article_vulnerabilities, :id,               unique: true
  add_index :article_vulnerabilities, :vulnerability_id, unique: false
  add_index :article_vulnerabilities, :article_id,       unique: false

  create_table "article_tags", force: :cascade do |t|
    t.integer :article_id, null: false
    t.integer :tag_id,     null: false
  end

  add_index :article_tags, :id,         unique: true
  add_index :article_tags, :tag_id,     unique: false
  add_index :article_tags, :article_id, unique: false

  create_table "article_filepaths", force: :cascade do |t|
    t.integer :article_id,  null: false
    t.integer :filepath_id, null: false
  end

  add_index :article_filepaths, :id,          unique: true
  add_index :article_filepaths, :filepath_id, unique: false
  add_index :article_filepaths, :article_id,  unique: false

  create_table "commit_filepaths", force: :cascade do |t|
    t.integer  "commit_id",   null: false
    t.integer  "filepath_id", null: false
    t.integer  "total_churn", null: false, default: 0
    t.integer  "insertions",  null: false, default: 0
    t.integer  "deletions",   null: false, default: 0
  end

  add_index :commit_filepaths, :id,          unique: true
  add_index :commit_filepaths, [:commit_id, :filepath_id], unique: true
  add_index :commit_filepaths, :commit_id,   unique: false
  add_index :commit_filepaths, :filepath_id, unique: false
  add_index :commit_filepaths, :total_churn, unique: false

  create_table "commits", force: :cascade do |t|
    t.string   "commit_hash",  null: false
    t.integer  "author_id",    null: false
    t.string   "message",      null: false, limit: 3000
    t.datetime "date_created", null: false
    t.jsonb    "notes",        null: false, default: {}
  end

  add_index :commits, :id,          unique: true
  add_index :commits, :commit_hash, unique: true
  add_index :commits, :author_id,   unique: false
  add_index :commits, :notes,       unique: false, using: :gin

  create_table "developers", force: :cascade do |t|
    t.string   "email",    null: false
    t.string   "nickname", null: false
    t.jsonb    "notes",    null: false, default: {}
  end

  add_index :developers, :id,       unique: true
  add_index :developers, :email,    unique: false
  add_index :developers, :nickname, unique: false

  create_table "events", force: :cascade do |t|
    t.string   "title",             null: false, default: 'Event'
    t.string   "description",       null: false, default: ''
    t.string   "event_type",        null: false, default: ''
    t.string   "date",              null: false
    t.string   "color",             null: false, default: '#ccc'
    t.string   "icon",              null: false, default: 'info'
    t.boolean  "start_hidden",      null: false, default: false
    t.integer   "vulnerability_id", null: false
    t.jsonb    "notes",             null: false, default: {}
  end

  add_index :events, :id,   unique: true
  add_index :events, :vulnerability_id, unique: false
  add_index :events, :event_type, unique: false

  create_table "filepaths", force: :cascade do |t|
    t.string   "filepath",   null: false
    t.string   "slug",       null: false
    t.string   "dir",        null: false, default: ''
    t.boolean  "is_code",    null: false, default: true
    t.string   "note",       null: false, default: ''
    t.integer  "project_id", null: false, default: 0
  end

  add_index :filepaths, :id,       unique: true
  add_index :filepaths, :slug,     unique: true
  add_index :filepaths, :note,     unique: false
  add_index :filepaths, :filepath, unique: false
  add_index :filepaths, :dir,      unique: false

  create_table "releases", force: :cascade do |t|
    t.string   "name",          null: false
    t.datetime "date_released", null: false
    t.jsonb    "notes",         null: false
    t.integer  "project_id",    null: false, default: 0
  end

  add_index :releases, :id,    unique: true
  add_index :releases, :project_id, unique: false
  add_index :releases, :notes, unique: false, using: :gin

  create_table "fixes", force: :cascade do |t|
    t.integer  "commit_id",        null: false
    t.integer  "vulnerability_id", null: false
    t.jsonb    "notes",            null: false, default: {}
  end

  add_index :fixes, :id,    unique: true
  add_index :fixes, :notes, unique: false, using: :gin

  create_table "interesting_commits", force: :cascade do |t|
    t.integer  "commit_id",        null: false
    t.integer  "vulnerability_id", null: false
    t.string   "note",             null: false, default: ""
  end

  add_index :interesting_commits, :id,    unique: true
  add_index :interesting_commits, :note,  unique: false

  create_table "tags", force: :cascade do |t|
    t.string "name",                      null: false
    t.string "shortname",                 null: false
    t.string "description", default: "",  null: false
    t.string "color",       default: "#696969", null: false
    t.string "icon",        default: "tag", null: false
  end

  add_index :tags, :id,        unique: true
  add_index :tags, :shortname, unique: true

  create_table "vccs", force: :cascade do |t|
    t.integer  "commit_id",        null: false
    t.integer  "vulnerability_id", null: false
    t.jsonb    "notes",            null: false, default: {}
  end

  add_index :vccs, :id,     unique: true
  add_index :vccs, :notes, unique: false, using: :gin

  create_table "vulnerabilities", force: :cascade do |t|
    t.string   "cve",           null: false
    t.integer  "project_id",    null: false, default: 0
    t.datetime "announced",     null: false
    t.string   "description",   null: false, default: ''
    t.string   "short_desc",    null: false, default: ''
    t.integer  "upvotes",       null: false, default: 0
    t.string   "nickname",      default: ''
    t.jsonb    "notes",         null: false, default: {}
  end

  add_index :vulnerabilities, :id,         unique: true
  add_index :vulnerabilities, :project_id, unique: false
  add_index :vulnerabilities, :upvotes, unique: false, order: { upvotes: "DESC NULLS LAST" }
  add_index :vulnerabilities, :notes,   unique: false, using: :gin

  create_table "vulnerability_tags", force: :cascade do |t|
    t.integer "vulnerability_id", null: false
    t.integer "tag_id",           null: false
    t.string  "note",             null: false, default: ''
    t.float   "importance",       null: false, default: 0.0
  end

  add_index :vulnerability_tags, :id,               unique: true
  add_index :vulnerability_tags, :tag_id,           unique: false
  add_index :vulnerability_tags, :vulnerability_id, unique: false, order: { importance: :desc }
  add_index :vulnerability_tags, [:tag_id, :vulnerability_id], unique: false, order: { importance: :desc }

  create_table "projects", force: :cascade do |t|
    t.string "name",                        null: false, default: ''
    t.string 'fullname',                    null: false, default: ''
    t.string "subdomain",                   null: false, default: ''
    t.string "fg_color" ,                   null: false, default: '#fff'
    t.string "bg_color",                    null: false, default: '#666'
    t.string "project_url",                 null: false, default: ''
    t.string "logo",                        null: false, default: ''
    t.string 'git_commit_url_prefix',       null: false, default: ''
    t.string 'github_search_url_prefix',    null: false, default: ''
    t.string 'github_edit_cve_url_prefix',  null: false, default: ''
    t.text   "description",                 null: false, default: ''
    t.text   "vulnerabilities_description", null: false, default: ''
    t.text   "developers_description",      null: false, default: ''
  end

  add_index :projects, :id,        unique: true
  add_index :projects, :name,      unique: true
  add_index :projects, :subdomain, unique: true

end
