require_relative '../../app/helpers/application_helper'

class VulnerabilityEvents
  include ApplicationHelper

  def initialize(project)
    @project = project
    @desc_template = "The vulnerability was officially announced by the development team."
  end

  def generate
    Vulnerability.where(project: @project).each do |v|
        Event.create!(
          date: v.announced,
          vulnerability: v,
          event_type: 'announced',
          title: "Vulnerability Announced for #{v.cve}",
          description: @desc_template,
          icon: 'bug_report',
          color: '#9DD5D5',
          notes: {},
          start_hidden: false
        )
    end
  end

end
