class CodeNoteLoader

  def load_data(repo_path, _project)
    Dir["#{repo_path}/code/*.yml"].each do |file|
      begin
        yml = File.open(file) { |f| YAML.load(f) }
        yml['filepaths'].each do |filepath|
          annotate(filepath, yml['note'])
        end
      rescue => e
        $stderr.puts "Error loading vuln file #{file}. Cause:"
        raise e
      end
    end
  end

  def annotate(filepath_str, note)
    f = Filepath.find_by(filepath: filepath_str)
    if f.nil?
      $stderr.puts "WARNING: Filepath not found: #{filepath_str}"
    else
      f.note = note
      f.save
    end
  end

end
