require 'json'

class ProjectLoader
  def load_data(repo_path)
    file = "#{repo_path}/project.yml"
    yml = File.open(file) { |f| YAML.load(f) }
    Project.create!(
      name:                        yml['name'],
      fullname:                    yml['fullname'],
      subdomain:                   yml['subdomain'],
      project_url:                 yml['project_url'],
      description:                 yml['description'],
      git_commit_url_prefix:       yml['git_commit_url_prefix'],
      github_search_url_prefix:    yml['github_search_url_prefix'],
      github_edit_cve_url_prefix:  yml['github_edit_cve_url_prefix'],
      vulnerabilities_description: yml['vulnerabilities_description'],
      developers_description:      yml['developers_description'],
      logo:                        "#{yml['subdomain']}.png",
      bg_color:                    yml['bg_color']
    )
  end
end
