class ReleaseLoader
  def load_data(repo_path, project)
    Dir["#{repo_path}/releases/*.yml"].each do |file|
      yml = File.open(file) { |f| YAML.load(f) }
      yml.each do | release_name, notes |
        notes['date']&.each do |date, name|
          Release.create!(
            name: "#{release_name.to_s} #{name}",
            date_released: date,
            notes: notes,
            project_id: project.id,
          )
        end
      end
    end
  end
end
