require_relative '../writing'
class DEPSTagger

  def initialize(project)
    @project = project
  end

  def create_tags
    @DEPS_tag = Tag.find_or_create_by!(
      name: 'Dependency Issue',
      shortname: 'dependency',
      color: '#dbe045',
      icon: 'dependency',
      description: Writing.tag_article('dependency')
    )
  end

  def apply_tags
    Vulnerability.joins([:project, fixes: {commit: :filepaths}])
                 .where("filepaths.filepath = 'DEPS'")
                 .where(project: @project)
                 .each do |v|
      VulnerabilityTag.create!(
        vulnerability: v,
        importance: 0.15, #sorta important, but not really
        tag: @DEPS_tag
      )
    end
  end
end
