class ProjectTagger

  def initialize(project)
    @project = project
  end

  def initialize(repo_dir, project)
    @repo_dir = repo_dir
    @project = project
  end

  def create_tags
    @tag = Tag.find_or_initialize_by(
      name: "Project: #{@project.name}",
      shortname: "project-#{@project.subdomain}",
      color: @project.bg_color,
      description: "Vulnerabilities reported in #{@project.fullname}\n\n" + @project.description
    )
  end

  def apply_tags
    Vulnerability.where(project: @project).each do |v|
      VulnerabilityTag.create!(
        vulnerability: v,
        tag: @tag,
        note: ''
      )
    end
  end

end
