require_relative '../writing'
class UnitTestTagger

  def initialize(project)
    @project = project
  end

  def create_tags
    @escaped_tag = Tag.find_by(shortname: 'escaped')
    if not @escaped_tag
      @escaped_tag = Tag.create!(
          name: 'Lesson: Escaped Test',
          shortname: 'escaped',
          color: '#009696',
          icon: 'lemon',
          description: Writing.tag_article('escaped')
      )
    end

    @lacked_tag = Tag.find_by(shortname: 'lacked-test')
    if not @lacked_tag
      @lacked_tag = Tag.create!(
          name: 'Lesson: Lacked Test',
          shortname: 'lacked-test',
          color: '#009696',
          icon: 'running',
          description: Writing.tag_article('lacked-test')
      )
    end

    @untested_tag = Tag.find_by(shortname: 'untested')
    if not @untested_tag
      @untested_tag = Tag.create!(
          name: 'Lesson: Fix Untested',
          shortname: 'untested',
          color: '#009696',
          icon: 'stamp',
          description: Writing.tag_article('untested')
      )
    end
  end

  def apply_tags
    Vulnerability.where(project: @project).each do |v|
      findTags(v)
      @tags.each do |t|
        VulnerabilityTag.create!(
                            vulnerability: v,
                            tag: t,
                            importance: 0.35, # these are higher on the importance scale, but all the same for this tagger
                            note: <<~EOS
                              #{v.notes.dig('unit_tested', 'answer').to_s.sub!("\n", ' ')}
                            EOS
        )
      end
    end
  end

  def findTags(v)
    @tags = []
    if v.notes.dig('unit_tested', 'code') == true
      @tags << @escaped_tag
    end
    if v.notes.dig('unit_tested', 'code') == false
      @tags << @lacked_tag
    end
    if v.notes.dig('unit_tested', 'fix') == true
      @tags << @untested_tag
    end
  end

end
