desc 'Clean rebuild of ALL data: Chromium, HTTPD'
namespace :data do
  task :all => %w(
    environment
    data:no_logger
    data:writing:github_clone
    data:clear
    data:chromium
    data:httpd
    data:tomcat
    data:struts
    data:writing
    data:done
  )

  desc 'Disable AR logging, for performance'
  task :no_logger => :environment do
    ActiveRecord::Base.logger = nil
  end

  desc 'Show some basic stats when the build is done'
  task :done => :environment do
    logger = TimingLogger.new(STDOUT, 'data:done')
    logger.info "#{Vulnerability.count} vulnerabilities"
    logger.info "#{Event.count} events"
    logger.info "#{Tag.count} tags"
    logger.info "#{Developer.count} developers"
    logger.info "#{Article.count} articles"
    logger.info "#{Filepath.count} filepaths"
    logger.done
  end

end
