require 'timing_logger'

logger = TimingLogger.new(STDOUT, 'data')

namespace 'data' do
  desc 'Optimize tables '
  task :optimize => :environment do
    logger.info "Optimizing tables"
    ActiveRecord::Base.connection.execute "CLUSTER vulnerabilities USING index_vulnerabilities_on_upvotes"
    ActiveRecord::Base.connection.execute "CLUSTER vulnerability_tags USING index_vulnerability_tags_on_tag_id_and_vulnerability_id"
    ActiveRecord::Base.connection.execute "ANALYZE events"
    ActiveRecord::Base.connection.execute "ANALYZE vulnerabilities"
    ActiveRecord::Base.connection.execute "ANALYZE vulnerability_tags"
    ActiveRecord::Base.connection.execute "ANALYZE tags"
  end
end
