require 'test_helper'

class CommitsControllerTest < ActionDispatch::IntegrationTest

    test 'Checks basic route functionality' do
      assert_generates '/commits', controller: 'commits', action: 'index'
      assert_routing '/commits', controller: 'commits', action: 'index'
      assert_recognizes({controller: 'commits', action: 'index'}, 'commits')
    end

    test 'Checks show functionality with full commit hash' do
      assert_routing '/commits/cfebb479b8e2498f63912c095fe57d84576bcfcf', controller: 'commits', action: 'show', id: 'cfebb479b8e2498f63912c095fe57d84576bcfcf'
      assert_recognizes({controller: 'commits', action: 'show', id: '488'}, "/commits/488")
    end

    test 'Checks show functionality with short commit hash' do
      assert_routing '/commits/cfebb479', controller: 'commits', action: 'show', id: 'cfebb479'
      assert_recognizes({controller: 'commits', action: 'show', id: '488'}, "/commits/488")
    end

    test 'Checks show functionality with id' do
      assert_routing '/tags/488', controller: 'tags', action: 'show', id: '488'
    end

    test 'Bad ID redirects' do
      get '/commits/0000'
      assert_redirected_to "/commits"
    end

    test 'Bad commit hash redirects' do
      get '/commits/invalid1210392commithash'
      assert_redirected_to "/commits"
    end



end
