require 'test_helper'

class TagsControllerTest < ActionDispatch::IntegrationTest
  # Andy deleted the auto-generated tests. Go look into Git history get them
  # back when we decide to write these tests.
  test 'Checks basic route functionality' do
    assert_generates '/tags', controller: 'tags', action: 'index'
    assert_routing '/tags', controller: 'tags', action: 'index'
    assert_recognizes({controller: 'tags', action: 'index'}, 'tags')
  end

  test 'Checks show functionality with shortname' do
    assert_routing '/tags/Java', controller: 'tags', action: 'show', id: 'Java'
    assert_recognizes({controller: 'tags', action: 'show', id: 'Java'}, "/tags/Java")
  end

  test 'Checks show functionality with id' do
    assert_routing '/tags/104', controller: 'tags', action: 'show', id: '104'
    #assert_recognizes({contoller: 'tags', action:'show', id: '104'}, "/tags/104")
  end

  test 'Bad ID redirects' do
    get '/tags/12345'
    assert_redirected_to '/tags'
  end

  test 'Bad tag redirects' do
    get '/tags/notarealtag'
    assert_redirected_to "/tags"
  end



end
