require 'test_helper'
require 'writing'
require_all 'lib/event_generators/*.rb'

class AllLulnerabilityEventsTest < ActiveSupport::TestCase

  setup do
    p = projects(:one)
    @silent_logger = TimingLogger.new(StringIO.new, '')
    VulnerabilityEvents.new(p).generate
    FixEvents.new(p, @silent_logger).generate
    VccEvents.new(p, @silent_logger).generate
    BountyEvents.new(p).generate
  end

  test 'get all vulnerability events' do
    v = Vulnerability.find_by(cve: 'CVE-2011-3092')
    expected = [
      "Bounty awarded for CVE-2011-3092",
      "CWE Determined for CVE-2013-2878",
      "Custom CVE-2011-3092 Event 2",
      "Custom Event 1", "Event",
      "Fix for CVE-2011-3092: Strip CRs from *.in files to allow building from webkit.org",
      "Vulnerability Announced for CVE-2011-3092",
      "Vulnerability-contributing commit for CVE-2011-3092: Remove empty unused directories from src/webkit.",
      "Vulnerability-contributing commit for CVE-2011-3092: WebKit merge 39606:39660 Review URL: http://codereview.chromium.org/17239"
    ]
    actual = v.events.map { |e| e.title.to_s }.sort
    assert_equal expected, actual
  end

end
