require 'test_helper'
require 'event_generators/bounty_events'
require 'writing'

class BountyEventsTest < ActiveSupport::TestCase

  test 'bounty events created for all vulns' do
    p = projects(:one)
    BountyEvents.new(p).generate
    expected = [
      "Bounty awarded for CVE-2011-3092"
    ]
    result = Event.where("title LIKE '%Bounty awarded%'")
    actual = result.map { |e| e.title }.sort
    assert_equal expected, actual
    assert_match /A bounty of \$1000\.0*/, result[0].description
  end

end
