require 'test_helper'
require 'event_generators/same_cwe_events'
require 'writing'

class SameCweEventsTest < ActiveSupport::TestCase

  setup do
    @silent_logger = TimingLogger.new(StringIO.new, '')
  end

  test 'same CWE events generated properly' do
    expected = [
      "Another Example vulnerability announced",
      "Another Example vulnerability announced"
    ]
    SameCweEvents.new(projects(:one), @silent_logger).generate
    actual = Event.where("title LIKE '%Another % vulnerability announced%'")
                  .pluck(:title).sort
    assert_equal expected, actual
  end
end
