require 'test_helper'
require 'event_generators/same_directory_events'
require 'writing'

class SameDirectoryEventsTest < ActiveSupport::TestCase

  setup do
    @silent_logger = TimingLogger.new(StringIO.new, '')
  end

  test 'same directory generated properly' do
    expected = [
        "CVE-2011-3092 fixed in same directory ",
        "CVE-2011-3092 fixed in same directory this/is/a/test",
        "CVE-2011-3092 fixed in same directory this/is/a/test",
        "CVE-2011-3092 fixed in same directory webkit/port",
        "CVE-2011-3093 fixed in same directory ",
        "CVE-2011-3093 fixed in same directory this/is/a/test",
        "CVE-2011-3093 fixed in same directory this/is/a/test",
        "CVE-2011-3093 fixed in same directory webkit/port",
        "CVE-2016-1676 fixed in same directory this/is/a/test",
        "CVE-2016-1676 fixed in same directory this/is/a/test"
    ]
    SameDirectoryEvents.new(projects(:one), @silent_logger).generate()
    actual = Event.where("title LIKE '%fixed in same directory%'")
                  .pluck(:title).sort
    assert_equal expected, actual
  end
end
