require 'test_helper'
require 'event_generators/vcc_events'
require 'writing'

class VccEventsTest < ActiveSupport::TestCase

  setup do
    @silent_logger = TimingLogger.new(StringIO.new, '')
  end

  test 'vcc events created for all vccs' do
    p = projects(:one)
    VccEvents.new(p, @silent_logger).generate
    expected = [
      "Vulnerability-contributing commit for CVE-2011-3092: Remove empty unused directories from src/webkit.",
      "Vulnerability-contributing commit for CVE-2011-3092: WebKit merge 39606:39660 Review URL: http://codereview.chromium.org/17239",
      "Vulnerability-contributing commit for CVE-2011-3093: SimplifiedBackwardsTextIterator returns incorrect offset with first-letter rule",
      "Vulnerability-contributing commit for CVE-2013-2878: SimplifiedBackwardsTextIterator returns incorrect offset with first-letter rule"
    ]
    actual = Event.where(event_type: 'vcc').
                   map { |e| e.title }.sort
    assert_equal expected, actual
  end

end
