require 'test_helper'
require 'event_generators/vulnerability_events'
require 'writing'

class VulnerabilityEventsTest < ActiveSupport::TestCase


  test 'vuln announcement events created for all vulns' do
    p = projects(:one)
    VulnerabilityEvents.new(p).generate
    expected = [
      # dup because we already have one in fixtures
      "Vulnerability Announced for CVE-2011-3092",
      "Vulnerability Announced for CVE-2011-3093",
      "Vulnerability Announced for CVE-2013-2878",
      "Vulnerability Announced for CVE-2016-1676"
    ]
    actual = Event.where("title LIKE 'Vulnerability Announced %'").
                   map { |e| e.title }.sort
    assert_equal expected, actual
  end

end
