require 'test_helper'
require 'taggers/DEPS_tagger'

class DEPSTagTest < ActiveSupport::TestCase

  test 'lesson tags created' do
    p = projects(:one)
    t = DEPSTagger.new(p)
    t.create_tags
    assert_equal(1, Tag.where(shortname: 'dependency').size)
  end

  test 'DEPS tag not duplicated' do
    p = projects(:one)
    t = DEPSTagger.new(p)
    tag_count_before = Tag.all.size
    if Tag.exists?(shortname: 'DEPS')
      tag_count_after = Tag.all.size
      assert_equal(tag_count_before, tag_count_after)
    end
  end

  test 'DEPS tag applied' do
    p = projects(:one)
    t = DEPSTagger.new(p)
    t.create_tags
    t.apply_tags
    tag = Tag.find_by(shortname: 'dependency')
    assert(tag)
    vt = VulnerabilityTag.find_by(tag_id: tag.id)
    assert(vt)
    assert(vt.note)
  end

end
