require 'test_helper'
require 'taggers/language_tagger'

class LanguageTagTest < ActiveSupport::TestCase
  test 'language tags created' do
    t = LanguageTagger.new(projects(:one))
    t.create_tags
    assert_equal(1, Tag.where(shortname: 'language-c').size)
    assert_equal(1, Tag.where(shortname: 'language-cpp').size)
    assert_equal(1, Tag.where(shortname: 'language-java').size)
    assert_equal(1, Tag.where(shortname: 'language-js').size)
    assert_equal(1, Tag.where(shortname: 'language-python').size)
    assert_equal(1, Tag.where(shortname: 'language-ruby').size)
  end

  test 'C tag applied' do
    t = LanguageTagger.new(projects(:one))
    t.create_tags
    t.apply_tags
    tag = Tag.find_by(shortname: 'language-c')
    assert(tag)
    vt = VulnerabilityTag.find_by(tag_id: tag.id)
    assert(vt)
    assert(vt.note)
  end

  test 'C++ tag applied' do
    t = LanguageTagger.new(projects(:one))
    t.create_tags
    t.apply_tags
    tag = Tag.find_by(shortname: 'language-cpp')
    assert(tag)
    vt = VulnerabilityTag.find_by(tag_id: tag.id)
    assert(vt)
    assert(vt.note)
  end

  test 'Java tag applied' do
    t = LanguageTagger.new(projects(:one))
    t.create_tags
    t.apply_tags
    tag = Tag.find_by(shortname: 'language-java')
    assert(tag)
    vt = VulnerabilityTag.find_by(tag_id: tag.id)
    assert(vt)
    assert(vt.note)
  end

  test 'Javascript tag applied' do
    t = LanguageTagger.new(projects(:one))
    t.create_tags
    t.apply_tags
    tag = Tag.find_by(shortname: 'language-js')
    assert(tag)
    vt = VulnerabilityTag.find_by(tag_id: tag.id)
    assert(vt)
    assert(vt.note)
  end

  test 'Python tag applied' do
    t = LanguageTagger.new(projects(:one))
    t.create_tags
    t.apply_tags
    tag = Tag.find_by(shortname: 'language-python')
    assert(tag)
    vt = VulnerabilityTag.find_by(tag_id: tag.id)
    assert(vt)
    assert(vt.note)
  end

end
