require 'test_helper'

class FilepathTest < ActiveSupport::TestCase
  test 'Makes sure there is right ammount of fixtures' do
    assert Filepath.any?
  end

  test 'dev fixture data are loaded1' do
    assert_equal 'DEPS', filepaths(:deps).filepath
  end

  test 'dev fixture data are loaded' do
    assert_equal 'webkit/port/DerivedSources.make', filepaths(:makefile).filepath
  end
  test 'filepath has developers' do
    assert_equal 'dglazkov@google.com', filepaths(:deps).developers.first.email
    assert_equal 'dglazkov@google.com', filepaths(:makefile).developers[0].email
  end

  test 'Filepath.vulnerable(v) joins on fixes' do
    expected = [
      filepaths(:deps),
      filepaths(:similar_path1),
      filepaths(:makefile)
    ]
    actual = Filepath.vulnerable(vulnerabilities(:cve_2011_3092)).
                      to_a.sort { |a,b| a.filepath <=> b.filepath}
    assert_equal expected, actual
  end

  test 'Filepath.compute_dir finds various directories' do
    assert_equal 'foo/', Filepath.compute_dir('foo/bar.c')
    assert_equal 'foo/bar/', Filepath.compute_dir('foo/bar/baz.c')
    assert_equal '/', Filepath.compute_dir('CHANGES')
  end

end
