require 'test_helper'
require 'writing'

class WritingTest < ActiveSupport::TestCase

  test 'no details embedded' do
    v = vulnerabilities(:cve_2011_3092)
    tmpl = 'no details'
    assert_equal 'no details', Writing.embed_details(tmpl, v)
  end

  test 'double layer note' do
    v = vulnerabilities(:cve_2011_3092)
    tmpl = '$:notes~bounty~amount:'
    assert_equal '$1000.0', Writing.embed_details(tmpl, v)
  end

  test 'empty notes field fails fine' do 
    no_notes = vulnerabilities(:cve_2011_5904)
    tmpl = ':notes~bounty~amount:'
    assert_equal tmpl, Writing.embed_details(tmpl, no_notes)
  end

end
